import { CorporateUser, Group, User, Type } from "@/interfaces/user";
import axios from "axios";

export const isUserFromCorporate = async (userID: string) => {
  const groups = (await axios.get<Group[]>(`/api/groups?participant=${userID}`))
    .data;
  const usersData = (await axios.get<{users: User[], total: number}>("/api/users/list")).data;

  const adminTypes = groups.reduce((accm: Type[], g) => {
    const user = usersData.users.find((u) => u.id === g.admin);
    if (user) {
      return [...accm, user.type];
    }

    return accm;
  }, []);
  return adminTypes.includes("corporate");
};

const getAdminForGroup = async (userID: string, role: Type) => {
  const groups = (await axios.get<Group[]>(`/api/groups?participant=${userID}`))
    .data;

  const adminRequests = await Promise.all(
    groups.map(async (g) => {
      const userRequest = await axios.get<User>(`/api/users/${g.admin}`);
      if (userRequest.status === 200) return userRequest.data;
      return undefined;
    })
  );

  const admins = adminRequests.filter((x) => x?.type === role);
  return admins.length > 0 ? (admins[0] as CorporateUser) : undefined;
};

export const getUserCorporate = async (
  userID: string
): Promise<CorporateUser | undefined> => {
  const userRequest = await axios.get<User>(`/api/users/${userID}`);
  if (userRequest.status === 200) {
    const user = userRequest.data;
    if (user.type === "corporate") {
      return getAdminForGroup(userID, "mastercorporate");
    }
  }

  return getAdminForGroup(userID, "corporate");
};
